<?php

namespace Mnm\EnumType;

/**
 * This class stands for DocumentResponseEntityStatus EnumType
 * @subpackage Enumerations
 */
class DocumentResponseEntityStatus
{
    /**
     * Constant for value 'Waiting'
     * @return string 'Waiting'
     */
    const VALUE_WAITING = 'Waiting';
    /**
     * Constant for value 'Queued'
     * @return string 'Queued'
     */
    const VALUE_QUEUED = 'Queued';
    /**
     * Constant for value 'Processing'
     * @return string 'Processing'
     */
    const VALUE_PROCESSING = 'Processing';
    /**
     * Constant for value 'SentToGib'
     * @return string 'SentToGib'
     */
    const VALUE_SENT_TO_GIB = 'SentToGib';
    /**
     * Constant for value 'Success'
     * @return string 'Success'
     */
    const VALUE_SUCCESS = 'Success';
    /**
     * Constant for value 'Error'
     * @return string 'Error'
     */
    const VALUE_ERROR = 'Error';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_WAITING
     * @uses self::VALUE_QUEUED
     * @uses self::VALUE_PROCESSING
     * @uses self::VALUE_SENT_TO_GIB
     * @uses self::VALUE_SUCCESS
     * @uses self::VALUE_ERROR
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_WAITING,
            self::VALUE_QUEUED,
            self::VALUE_PROCESSING,
            self::VALUE_SENT_TO_GIB,
            self::VALUE_SUCCESS,
            self::VALUE_ERROR,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
