<?php

namespace Mnm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BranchType StructType
 * @subpackage Structs
 */
class BranchType extends AbstractStructBase
{
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - ref: q70:Name
     * @var \Mnm\StructType\NameType
     */
    public $Name;
    /**
     * The FinancialInstitution
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Mnm\StructType\FinancialInstitutionType
     */
    public $FinancialInstitution;
    /**
     * Constructor method for BranchType
     * @uses BranchType::setName()
     * @uses BranchType::setFinancialInstitution()
     * @param \Mnm\StructType\NameType $name
     * @param \Mnm\StructType\FinancialInstitutionType $financialInstitution
     */
    public function __construct(\Mnm\StructType\NameType $name = null, \Mnm\StructType\FinancialInstitutionType $financialInstitution = null)
    {
        $this
            ->setName($name)
            ->setFinancialInstitution($financialInstitution);
    }
    /**
     * Get Name value
     * @return \Mnm\StructType\NameType|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param \Mnm\StructType\NameType $name
     * @return \Mnm\StructType\BranchType
     */
    public function setName(\Mnm\StructType\NameType $name = null)
    {
        $this->Name = $name;
        return $this;
    }
    /**
     * Get FinancialInstitution value
     * @return \Mnm\StructType\FinancialInstitutionType|null
     */
    public function getFinancialInstitution()
    {
        return $this->FinancialInstitution;
    }
    /**
     * Set FinancialInstitution value
     * @param \Mnm\StructType\FinancialInstitutionType $financialInstitution
     * @return \Mnm\StructType\BranchType
     */
    public function setFinancialInstitution(\Mnm\StructType\FinancialInstitutionType $financialInstitution = null)
    {
        $this->FinancialInstitution = $financialInstitution;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Mnm\StructType\BranchType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
