<?php

namespace Mnm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ChangeInvoiceArchiveStatus StructType
 * @subpackage Structs
 */
class ChangeInvoiceArchiveStatus extends AbstractStructBase
{
    /**
     * The isInbox
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $isInbox;
    /**
     * The isArchived
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $isArchived;
    /**
     * The userInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Mnm\StructType\UserInformation
     */
    public $userInfo;
    /**
     * The invoiceIds
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Mnm\ArrayType\ArrayOfString
     */
    public $invoiceIds;
    /**
     * Constructor method for ChangeInvoiceArchiveStatus
     * @uses ChangeInvoiceArchiveStatus::setIsInbox()
     * @uses ChangeInvoiceArchiveStatus::setIsArchived()
     * @uses ChangeInvoiceArchiveStatus::setUserInfo()
     * @uses ChangeInvoiceArchiveStatus::setInvoiceIds()
     * @param bool $isInbox
     * @param bool $isArchived
     * @param \Mnm\StructType\UserInformation $userInfo
     * @param \Mnm\ArrayType\ArrayOfString $invoiceIds
     */
    public function __construct($isInbox = null, $isArchived = null, \Mnm\StructType\UserInformation $userInfo = null, \Mnm\ArrayType\ArrayOfString $invoiceIds = null)
    {
        $this
            ->setIsInbox($isInbox)
            ->setIsArchived($isArchived)
            ->setUserInfo($userInfo)
            ->setInvoiceIds($invoiceIds);
    }
    /**
     * Get isInbox value
     * @return bool
     */
    public function getIsInbox()
    {
        return $this->isInbox;
    }
    /**
     * Set isInbox value
     * @param bool $isInbox
     * @return \Mnm\StructType\ChangeInvoiceArchiveStatus
     */
    public function setIsInbox($isInbox = null)
    {
        $this->isInbox = $isInbox;
        return $this;
    }
    /**
     * Get isArchived value
     * @return bool
     */
    public function getIsArchived()
    {
        return $this->isArchived;
    }
    /**
     * Set isArchived value
     * @param bool $isArchived
     * @return \Mnm\StructType\ChangeInvoiceArchiveStatus
     */
    public function setIsArchived($isArchived = null)
    {
        $this->isArchived = $isArchived;
        return $this;
    }
    /**
     * Get userInfo value
     * @return \Mnm\StructType\UserInformation|null
     */
    public function getUserInfo()
    {
        return $this->userInfo;
    }
    /**
     * Set userInfo value
     * @param \Mnm\StructType\UserInformation $userInfo
     * @return \Mnm\StructType\ChangeInvoiceArchiveStatus
     */
    public function setUserInfo(\Mnm\StructType\UserInformation $userInfo = null)
    {
        $this->userInfo = $userInfo;
        return $this;
    }
    /**
     * Get invoiceIds value
     * @return \Mnm\ArrayType\ArrayOfString|null
     */
    public function getInvoiceIds()
    {
        return $this->invoiceIds;
    }
    /**
     * Set invoiceIds value
     * @param \Mnm\ArrayType\ArrayOfString $invoiceIds
     * @return \Mnm\StructType\ChangeInvoiceArchiveStatus
     */
    public function setInvoiceIds(\Mnm\ArrayType\ArrayOfString $invoiceIds = null)
    {
        $this->invoiceIds = $invoiceIds;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Mnm\StructType\ChangeInvoiceArchiveStatus
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
