<?php

namespace Mnm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CommunicationType StructType
 * @subpackage Structs
 */
class CommunicationType extends AbstractStructBase
{
    /**
     * The ChannelCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - ref: q58:ChannelCode
     * @var \Mnm\StructType\ChannelCodeType
     */
    public $ChannelCode;
    /**
     * The Channel
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - ref: q59:Channel
     * @var \Mnm\StructType\ChannelType
     */
    public $Channel;
    /**
     * The Value
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - ref: q60:Value
     * @var \Mnm\StructType\ValueType
     */
    public $Value;
    /**
     * Constructor method for CommunicationType
     * @uses CommunicationType::setChannelCode()
     * @uses CommunicationType::setChannel()
     * @uses CommunicationType::setValue()
     * @param \Mnm\StructType\ChannelCodeType $channelCode
     * @param \Mnm\StructType\ChannelType $channel
     * @param \Mnm\StructType\ValueType $value
     */
    public function __construct(\Mnm\StructType\ChannelCodeType $channelCode = null, \Mnm\StructType\ChannelType $channel = null, \Mnm\StructType\ValueType $value = null)
    {
        $this
            ->setChannelCode($channelCode)
            ->setChannel($channel)
            ->setValue($value);
    }
    /**
     * Get ChannelCode value
     * @return \Mnm\StructType\ChannelCodeType|null
     */
    public function getChannelCode()
    {
        return $this->ChannelCode;
    }
    /**
     * Set ChannelCode value
     * @param \Mnm\StructType\ChannelCodeType $channelCode
     * @return \Mnm\StructType\CommunicationType
     */
    public function setChannelCode(\Mnm\StructType\ChannelCodeType $channelCode = null)
    {
        $this->ChannelCode = $channelCode;
        return $this;
    }
    /**
     * Get Channel value
     * @return \Mnm\StructType\ChannelType|null
     */
    public function getChannel()
    {
        return $this->Channel;
    }
    /**
     * Set Channel value
     * @param \Mnm\StructType\ChannelType $channel
     * @return \Mnm\StructType\CommunicationType
     */
    public function setChannel(\Mnm\StructType\ChannelType $channel = null)
    {
        $this->Channel = $channel;
        return $this;
    }
    /**
     * Get Value value
     * @return \Mnm\StructType\ValueType|null
     */
    public function getValue()
    {
        return $this->Value;
    }
    /**
     * Set Value value
     * @param \Mnm\StructType\ValueType $value
     * @return \Mnm\StructType\CommunicationType
     */
    public function setValue(\Mnm\StructType\ValueType $value = null)
    {
        $this->Value = $value;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Mnm\StructType\CommunicationType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
