<?php

namespace Mnm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CompressedSendInvoice StructType
 * @subpackage Structs
 */
class CompressedSendInvoice extends AbstractStructBase
{
    /**
     * The userInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Mnm\StructType\UserInformation
     */
    public $userInfo;
    /**
     * The data
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Mnm\StructType\BinaryRequestData
     */
    public $data;
    /**
     * Constructor method for CompressedSendInvoice
     * @uses CompressedSendInvoice::setUserInfo()
     * @uses CompressedSendInvoice::setData()
     * @param \Mnm\StructType\UserInformation $userInfo
     * @param \Mnm\StructType\BinaryRequestData $data
     */
    public function __construct(\Mnm\StructType\UserInformation $userInfo = null, \Mnm\StructType\BinaryRequestData $data = null)
    {
        $this
            ->setUserInfo($userInfo)
            ->setData($data);
    }
    /**
     * Get userInfo value
     * @return \Mnm\StructType\UserInformation|null
     */
    public function getUserInfo()
    {
        return $this->userInfo;
    }
    /**
     * Set userInfo value
     * @param \Mnm\StructType\UserInformation $userInfo
     * @return \Mnm\StructType\CompressedSendInvoice
     */
    public function setUserInfo(\Mnm\StructType\UserInformation $userInfo = null)
    {
        $this->userInfo = $userInfo;
        return $this;
    }
    /**
     * Get data value
     * @return \Mnm\StructType\BinaryRequestData|null
     */
    public function getData()
    {
        return $this->data;
    }
    /**
     * Set data value
     * @param \Mnm\StructType\BinaryRequestData $data
     * @return \Mnm\StructType\CompressedSendInvoice
     */
    public function setData(\Mnm\StructType\BinaryRequestData $data = null)
    {
        $this->data = $data;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Mnm\StructType\CompressedSendInvoice
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
