<?php

namespace Mnm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CorporateRegistrationSchemeType StructType
 * @subpackage Structs
 */
class CorporateRegistrationSchemeType extends AbstractStructBase
{
    /**
     * The ID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - ref: q49:ID
     * @var \Mnm\StructType\IDType
     */
    public $ID;
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - ref: q50:Name
     * @var \Mnm\StructType\NameType
     */
    public $Name;
    /**
     * The CorporateRegistrationTypeCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - ref: q51:CorporateRegistrationTypeCode
     * @var \Mnm\StructType\CorporateRegistrationTypeCodeType
     */
    public $CorporateRegistrationTypeCode;
    /**
     * The JurisdictionRegionAddress
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Mnm\StructType\AddressType[]
     */
    public $JurisdictionRegionAddress;
    /**
     * Constructor method for CorporateRegistrationSchemeType
     * @uses CorporateRegistrationSchemeType::setID()
     * @uses CorporateRegistrationSchemeType::setName()
     * @uses CorporateRegistrationSchemeType::setCorporateRegistrationTypeCode()
     * @uses CorporateRegistrationSchemeType::setJurisdictionRegionAddress()
     * @param \Mnm\StructType\IDType $iD
     * @param \Mnm\StructType\NameType $name
     * @param \Mnm\StructType\CorporateRegistrationTypeCodeType $corporateRegistrationTypeCode
     * @param \Mnm\StructType\AddressType[] $jurisdictionRegionAddress
     */
    public function __construct(\Mnm\StructType\IDType $iD = null, \Mnm\StructType\NameType $name = null, \Mnm\StructType\CorporateRegistrationTypeCodeType $corporateRegistrationTypeCode = null, array $jurisdictionRegionAddress = array())
    {
        $this
            ->setID($iD)
            ->setName($name)
            ->setCorporateRegistrationTypeCode($corporateRegistrationTypeCode)
            ->setJurisdictionRegionAddress($jurisdictionRegionAddress);
    }
    /**
     * Get ID value
     * @return \Mnm\StructType\IDType|null
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param \Mnm\StructType\IDType $iD
     * @return \Mnm\StructType\CorporateRegistrationSchemeType
     */
    public function setID(\Mnm\StructType\IDType $iD = null)
    {
        $this->ID = $iD;
        return $this;
    }
    /**
     * Get Name value
     * @return \Mnm\StructType\NameType|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param \Mnm\StructType\NameType $name
     * @return \Mnm\StructType\CorporateRegistrationSchemeType
     */
    public function setName(\Mnm\StructType\NameType $name = null)
    {
        $this->Name = $name;
        return $this;
    }
    /**
     * Get CorporateRegistrationTypeCode value
     * @return \Mnm\StructType\CorporateRegistrationTypeCodeType|null
     */
    public function getCorporateRegistrationTypeCode()
    {
        return $this->CorporateRegistrationTypeCode;
    }
    /**
     * Set CorporateRegistrationTypeCode value
     * @param \Mnm\StructType\CorporateRegistrationTypeCodeType $corporateRegistrationTypeCode
     * @return \Mnm\StructType\CorporateRegistrationSchemeType
     */
    public function setCorporateRegistrationTypeCode(\Mnm\StructType\CorporateRegistrationTypeCodeType $corporateRegistrationTypeCode = null)
    {
        $this->CorporateRegistrationTypeCode = $corporateRegistrationTypeCode;
        return $this;
    }
    /**
     * Get JurisdictionRegionAddress value
     * @return \Mnm\StructType\AddressType[]|null
     */
    public function getJurisdictionRegionAddress()
    {
        return $this->JurisdictionRegionAddress;
    }
    /**
     * Set JurisdictionRegionAddress value
     * @param \Mnm\StructType\AddressType[] $jurisdictionRegionAddress
     * @return \Mnm\StructType\CorporateRegistrationSchemeType
     */
    public function setJurisdictionRegionAddress(array $jurisdictionRegionAddress = array())
    {
        $this->JurisdictionRegionAddress = $jurisdictionRegionAddress;
        return $this;
    }
    /**
     * Add item to JurisdictionRegionAddress value
     * @throws \InvalidArgumentException
     * @param \Mnm\StructType\AddressType $item
     * @return \Mnm\StructType\CorporateRegistrationSchemeType
     */
    public function addToJurisdictionRegionAddress(\Mnm\StructType\AddressType $item)
    {
        $this->JurisdictionRegionAddress[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Mnm\StructType\CorporateRegistrationSchemeType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
