<?php

namespace Mnm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomerInfo StructType
 * @subpackage Structs
 */
class CustomerInfo extends AbstractStructBase
{
    /**
     * The VknTckn
     * @var string
     */
    public $VknTckn;
    /**
     * The Alias
     * @var string
     */
    public $Alias;
    /**
     * The Title
     * @var string
     */
    public $Title;
    /**
     * Constructor method for CustomerInfo
     * @uses CustomerInfo::setVknTckn()
     * @uses CustomerInfo::setAlias()
     * @uses CustomerInfo::setTitle()
     * @param string $vknTckn
     * @param string $alias
     * @param string $title
     */
    public function __construct($vknTckn = null, $alias = null, $title = null)
    {
        $this
            ->setVknTckn($vknTckn)
            ->setAlias($alias)
            ->setTitle($title);
    }
    /**
     * Get VknTckn value
     * @return string|null
     */
    public function getVknTckn()
    {
        return $this->VknTckn;
    }
    /**
     * Set VknTckn value
     * @param string $vknTckn
     * @return \Mnm\StructType\CustomerInfo
     */
    public function setVknTckn($vknTckn = null)
    {
        $this->VknTckn = $vknTckn;
        return $this;
    }
    /**
     * Get Alias value
     * @return string|null
     */
    public function getAlias()
    {
        return $this->Alias;
    }
    /**
     * Set Alias value
     * @param string $alias
     * @return \Mnm\StructType\CustomerInfo
     */
    public function setAlias($alias = null)
    {
        $this->Alias = $alias;
        return $this;
    }
    /**
     * Get Title value
     * @return string|null
     */
    public function getTitle()
    {
        return $this->Title;
    }
    /**
     * Set Title value
     * @param string $title
     * @return \Mnm\StructType\CustomerInfo
     */
    public function setTitle($title = null)
    {
        $this->Title = $title;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Mnm\StructType\CustomerInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
