<?php

namespace Mnm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomerPartyType StructType
 * @subpackage Structs
 */
class CustomerPartyType extends AbstractStructBase
{
    /**
     * The Party
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Mnm\StructType\PartyType
     */
    public $Party;
    /**
     * The DeliveryContact
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Mnm\StructType\ContactType
     */
    public $DeliveryContact;
    /**
     * Constructor method for CustomerPartyType
     * @uses CustomerPartyType::setParty()
     * @uses CustomerPartyType::setDeliveryContact()
     * @param \Mnm\StructType\PartyType $party
     * @param \Mnm\StructType\ContactType $deliveryContact
     */
    public function __construct(\Mnm\StructType\PartyType $party = null, \Mnm\StructType\ContactType $deliveryContact = null)
    {
        $this
            ->setParty($party)
            ->setDeliveryContact($deliveryContact);
    }
    /**
     * Get Party value
     * @return \Mnm\StructType\PartyType|null
     */
    public function getParty()
    {
        return $this->Party;
    }
    /**
     * Set Party value
     * @param \Mnm\StructType\PartyType $party
     * @return \Mnm\StructType\CustomerPartyType
     */
    public function setParty(\Mnm\StructType\PartyType $party = null)
    {
        $this->Party = $party;
        return $this;
    }
    /**
     * Get DeliveryContact value
     * @return \Mnm\StructType\ContactType|null
     */
    public function getDeliveryContact()
    {
        return $this->DeliveryContact;
    }
    /**
     * Set DeliveryContact value
     * @param \Mnm\StructType\ContactType $deliveryContact
     * @return \Mnm\StructType\CustomerPartyType
     */
    public function setDeliveryContact(\Mnm\StructType\ContactType $deliveryContact = null)
    {
        $this->DeliveryContact = $deliveryContact;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Mnm\StructType\CustomerPartyType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
