<?php

namespace Mnm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DimensionType StructType
 * @subpackage Structs
 */
class DimensionType extends AbstractStructBase
{
    /**
     * The AttributeID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - ref: q158:AttributeID
     * @var \Mnm\StructType\AttributeIDType
     */
    public $AttributeID;
    /**
     * The Measure
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - ref: q159:Measure
     * @var \Mnm\StructType\MeasureType
     */
    public $Measure;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - ref: q160:Description
     * @var \Mnm\StructType\DescriptionType[]
     */
    public $Description;
    /**
     * The MinimumMeasure
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - ref: q161:MinimumMeasure
     * @var \Mnm\StructType\MinimumMeasureType
     */
    public $MinimumMeasure;
    /**
     * The MaximumMeasure
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - ref: q162:MaximumMeasure
     * @var \Mnm\StructType\MaximumMeasureType
     */
    public $MaximumMeasure;
    /**
     * Constructor method for DimensionType
     * @uses DimensionType::setAttributeID()
     * @uses DimensionType::setMeasure()
     * @uses DimensionType::setDescription()
     * @uses DimensionType::setMinimumMeasure()
     * @uses DimensionType::setMaximumMeasure()
     * @param \Mnm\StructType\AttributeIDType $attributeID
     * @param \Mnm\StructType\MeasureType $measure
     * @param \Mnm\StructType\DescriptionType[] $description
     * @param \Mnm\StructType\MinimumMeasureType $minimumMeasure
     * @param \Mnm\StructType\MaximumMeasureType $maximumMeasure
     */
    public function __construct(\Mnm\StructType\AttributeIDType $attributeID = null, \Mnm\StructType\MeasureType $measure = null, array $description = array(), \Mnm\StructType\MinimumMeasureType $minimumMeasure = null, \Mnm\StructType\MaximumMeasureType $maximumMeasure = null)
    {
        $this
            ->setAttributeID($attributeID)
            ->setMeasure($measure)
            ->setDescription($description)
            ->setMinimumMeasure($minimumMeasure)
            ->setMaximumMeasure($maximumMeasure);
    }
    /**
     * Get AttributeID value
     * @return \Mnm\StructType\AttributeIDType|null
     */
    public function getAttributeID()
    {
        return $this->AttributeID;
    }
    /**
     * Set AttributeID value
     * @param \Mnm\StructType\AttributeIDType $attributeID
     * @return \Mnm\StructType\DimensionType
     */
    public function setAttributeID(\Mnm\StructType\AttributeIDType $attributeID = null)
    {
        $this->AttributeID = $attributeID;
        return $this;
    }
    /**
     * Get Measure value
     * @return \Mnm\StructType\MeasureType|null
     */
    public function getMeasure()
    {
        return $this->Measure;
    }
    /**
     * Set Measure value
     * @param \Mnm\StructType\MeasureType $measure
     * @return \Mnm\StructType\DimensionType
     */
    public function setMeasure(\Mnm\StructType\MeasureType $measure = null)
    {
        $this->Measure = $measure;
        return $this;
    }
    /**
     * Get Description value
     * @return \Mnm\StructType\DescriptionType[]|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param \Mnm\StructType\DescriptionType[] $description
     * @return \Mnm\StructType\DimensionType
     */
    public function setDescription(array $description = array())
    {
        $this->Description = $description;
        return $this;
    }
    /**
     * Add item to Description value
     * @throws \InvalidArgumentException
     * @param \Mnm\StructType\DescriptionType $item
     * @return \Mnm\StructType\DimensionType
     */
    public function addToDescription(\Mnm\StructType\DescriptionType $item)
    {
        $this->Description[] = $item;
        return $this;
    }
    /**
     * Get MinimumMeasure value
     * @return \Mnm\StructType\MinimumMeasureType|null
     */
    public function getMinimumMeasure()
    {
        return $this->MinimumMeasure;
    }
    /**
     * Set MinimumMeasure value
     * @param \Mnm\StructType\MinimumMeasureType $minimumMeasure
     * @return \Mnm\StructType\DimensionType
     */
    public function setMinimumMeasure(\Mnm\StructType\MinimumMeasureType $minimumMeasure = null)
    {
        $this->MinimumMeasure = $minimumMeasure;
        return $this;
    }
    /**
     * Get MaximumMeasure value
     * @return \Mnm\StructType\MaximumMeasureType|null
     */
    public function getMaximumMeasure()
    {
        return $this->MaximumMeasure;
    }
    /**
     * Set MaximumMeasure value
     * @param \Mnm\StructType\MaximumMeasureType $maximumMeasure
     * @return \Mnm\StructType\DimensionType
     */
    public function setMaximumMeasure(\Mnm\StructType\MaximumMeasureType $maximumMeasure = null)
    {
        $this->MaximumMeasure = $maximumMeasure;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Mnm\StructType\DimensionType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
