<?php

namespace Mnm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetSummaryReport StructType
 * @subpackage Structs
 */
class GetSummaryReport extends AbstractStructBase
{
    /**
     * The startDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $startDate;
    /**
     * The endDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $endDate;
    /**
     * The userInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Mnm\StructType\UserInformation
     */
    public $userInfo;
    /**
     * Constructor method for GetSummaryReport
     * @uses GetSummaryReport::setStartDate()
     * @uses GetSummaryReport::setEndDate()
     * @uses GetSummaryReport::setUserInfo()
     * @param string $startDate
     * @param string $endDate
     * @param \Mnm\StructType\UserInformation $userInfo
     */
    public function __construct($startDate = null, $endDate = null, \Mnm\StructType\UserInformation $userInfo = null)
    {
        $this
            ->setStartDate($startDate)
            ->setEndDate($endDate)
            ->setUserInfo($userInfo);
    }
    /**
     * Get startDate value
     * @return string
     */
    public function getStartDate()
    {
        return $this->startDate;
    }
    /**
     * Set startDate value
     * @param string $startDate
     * @return \Mnm\StructType\GetSummaryReport
     */
    public function setStartDate($startDate = null)
    {
        $this->startDate = $startDate;
        return $this;
    }
    /**
     * Get endDate value
     * @return string
     */
    public function getEndDate()
    {
        return $this->endDate;
    }
    /**
     * Set endDate value
     * @param string $endDate
     * @return \Mnm\StructType\GetSummaryReport
     */
    public function setEndDate($endDate = null)
    {
        $this->endDate = $endDate;
        return $this;
    }
    /**
     * Get userInfo value
     * @return \Mnm\StructType\UserInformation|null
     */
    public function getUserInfo()
    {
        return $this->userInfo;
    }
    /**
     * Set userInfo value
     * @param \Mnm\StructType\UserInformation $userInfo
     * @return \Mnm\StructType\GetSummaryReport
     */
    public function setUserInfo(\Mnm\StructType\UserInformation $userInfo = null)
    {
        $this->userInfo = $userInfo;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Mnm\StructType\GetSummaryReport
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
