<?php

namespace Mnm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OutboxInvoiceListItem StructType
 * @subpackage Structs
 */
class OutboxInvoiceListItem extends InvoiceListItemBase
{
    /**
     * The Scenario
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Scenario;
    /**
     * The ScenarioCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $ScenarioCode;
    /**
     * The LocalDocumentId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LocalDocumentId;
    /**
     * The ExtraInformation
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ExtraInformation;
    /**
     * Constructor method for OutboxInvoiceListItem
     * @uses OutboxInvoiceListItem::setScenario()
     * @uses OutboxInvoiceListItem::setScenarioCode()
     * @uses OutboxInvoiceListItem::setLocalDocumentId()
     * @uses OutboxInvoiceListItem::setExtraInformation()
     * @param string $scenario
     * @param int $scenarioCode
     * @param string $localDocumentId
     * @param string $extraInformation
     */
    public function __construct($scenario = null, $scenarioCode = null, $localDocumentId = null, $extraInformation = null)
    {
        $this
            ->setScenario($scenario)
            ->setScenarioCode($scenarioCode)
            ->setLocalDocumentId($localDocumentId)
            ->setExtraInformation($extraInformation);
    }
    /**
     * Get Scenario value
     * @return string
     */
    public function getScenario()
    {
        return $this->Scenario;
    }
    /**
     * Set Scenario value
     * @param string $scenario
     * @return \Mnm\StructType\OutboxInvoiceListItem
     */
    public function setScenario($scenario = null)
    {
        $this->Scenario = $scenario;
        return $this;
    }
    /**
     * Get ScenarioCode value
     * @return int
     */
    public function getScenarioCode()
    {
        return $this->ScenarioCode;
    }
    /**
     * Set ScenarioCode value
     * @param int $scenarioCode
     * @return \Mnm\StructType\OutboxInvoiceListItem
     */
    public function setScenarioCode($scenarioCode = null)
    {
        $this->ScenarioCode = $scenarioCode;
        return $this;
    }
    /**
     * Get LocalDocumentId value
     * @return string|null
     */
    public function getLocalDocumentId()
    {
        return $this->LocalDocumentId;
    }
    /**
     * Set LocalDocumentId value
     * @param string $localDocumentId
     * @return \Mnm\StructType\OutboxInvoiceListItem
     */
    public function setLocalDocumentId($localDocumentId = null)
    {
        $this->LocalDocumentId = $localDocumentId;
        return $this;
    }
    /**
     * Get ExtraInformation value
     * @return string|null
     */
    public function getExtraInformation()
    {
        return $this->ExtraInformation;
    }
    /**
     * Set ExtraInformation value
     * @param string $extraInformation
     * @return \Mnm\StructType\OutboxInvoiceListItem
     */
    public function setExtraInformation($extraInformation = null)
    {
        $this->ExtraInformation = $extraInformation;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Mnm\StructType\OutboxInvoiceListItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
