<?php

namespace Mnm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ReferenceType StructType
 * @subpackage Structs
 */
class ReferenceType extends TextType
{
    /**
     * The Transforms
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Mnm\ArrayType\ArrayOfTransformType
     */
    public $Transforms;
    /**
     * The DigestMethod
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Mnm\StructType\DigestMethodType
     */
    public $DigestMethod;
    /**
     * The DigestValue
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DigestValue;
    /**
     * The Id
     * @var string
     */
    public $Id;
    /**
     * The URI
     * @var string
     */
    public $URI;
    /**
     * The Type
     * @var string
     */
    public $Type;
    /**
     * The _
     * @var \Mnm\StructType\TextType
     */
    public $_;
    /**
     * Constructor method for ReferenceType
     * @uses ReferenceType::setTransforms()
     * @uses ReferenceType::setDigestMethod()
     * @uses ReferenceType::setDigestValue()
     * @uses ReferenceType::setId()
     * @uses ReferenceType::setURI()
     * @uses ReferenceType::setType()
     * @uses ReferenceType::set_()
     * @param \Mnm\ArrayType\ArrayOfTransformType $transforms
     * @param \Mnm\StructType\DigestMethodType $digestMethod
     * @param string $digestValue
     * @param string $id
     * @param string $uRI
     * @param string $type
     * @param \Mnm\StructType\TextType $_
     */
    public function __construct(\Mnm\ArrayType\ArrayOfTransformType $transforms = null, \Mnm\StructType\DigestMethodType $digestMethod = null, $digestValue = null, $id = null, $uRI = null, $type = null, \Mnm\StructType\TextType $_ = null)
    {
        $this
            ->setTransforms($transforms)
            ->setDigestMethod($digestMethod)
            ->setDigestValue($digestValue)
            ->setId($id)
            ->setURI($uRI)
            ->setType($type)
            ->set_($_);
    }
    /**
     * Get Transforms value
     * @return \Mnm\ArrayType\ArrayOfTransformType|null
     */
    public function getTransforms()
    {
        return $this->Transforms;
    }
    /**
     * Set Transforms value
     * @param \Mnm\ArrayType\ArrayOfTransformType $transforms
     * @return \Mnm\StructType\ReferenceType
     */
    public function setTransforms(\Mnm\ArrayType\ArrayOfTransformType $transforms = null)
    {
        $this->Transforms = $transforms;
        return $this;
    }
    /**
     * Get DigestMethod value
     * @return \Mnm\StructType\DigestMethodType|null
     */
    public function getDigestMethod()
    {
        return $this->DigestMethod;
    }
    /**
     * Set DigestMethod value
     * @param \Mnm\StructType\DigestMethodType $digestMethod
     * @return \Mnm\StructType\ReferenceType
     */
    public function setDigestMethod(\Mnm\StructType\DigestMethodType $digestMethod = null)
    {
        $this->DigestMethod = $digestMethod;
        return $this;
    }
    /**
     * Get DigestValue value
     * @return string|null
     */
    public function getDigestValue()
    {
        return $this->DigestValue;
    }
    /**
     * Set DigestValue value
     * @param string $digestValue
     * @return \Mnm\StructType\ReferenceType
     */
    public function setDigestValue($digestValue = null)
    {
        $this->DigestValue = $digestValue;
        return $this;
    }
    /**
     * Get Id value
     * @return string|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param string $id
     * @return \Mnm\StructType\ReferenceType
     */
    public function setId($id = null)
    {
        $this->Id = $id;
        return $this;
    }
    /**
     * Get URI value
     * @return string|null
     */
    public function getURI()
    {
        return $this->URI;
    }
    /**
     * Set URI value
     * @param string $uRI
     * @return \Mnm\StructType\ReferenceType
     */
    public function setURI($uRI = null)
    {
        $this->URI = $uRI;
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param string $type
     * @return \Mnm\StructType\ReferenceType
     */
    public function setType($type = null)
    {
        $this->Type = $type;
        return $this;
    }
    /**
     * Get _ value
     * @return \Mnm\StructType\TextType|null
     */
    public function get_()
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param \Mnm\StructType\TextType $_
     * @return \Mnm\StructType\ReferenceType
     */
    public function set_(\Mnm\StructType\TextType $_ = null)
    {
        $this->_ = $_;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Mnm\StructType\ReferenceType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
