<?php

namespace Mnm\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SystemUser StructType
 * @subpackage Structs
 */
class SystemUser extends EntityUpdatedHistory
{
    /**
     * The Enabled
     * Meta information extracted from the WSDL
     * - use: required
     * @var bool
     */
    public $Enabled;
    /**
     * The Identifier
     * @var string
     */
    public $Identifier;
    /**
     * The PostboxAlias
     * @var string
     */
    public $PostboxAlias;
    /**
     * The SenderboxAlias
     * @var string
     */
    public $SenderboxAlias;
    /**
     * The Title
     * @var string
     */
    public $Title;
    /**
     * The Type
     * @var string
     */
    public $Type;
    /**
     * The SystemCreateDate
     * @var string
     */
    public $SystemCreateDate;
    /**
     * The FirstCreateDate
     * @var string
     */
    public $FirstCreateDate;
    /**
     * Constructor method for SystemUser
     * @uses SystemUser::setEnabled()
     * @uses SystemUser::setIdentifier()
     * @uses SystemUser::setPostboxAlias()
     * @uses SystemUser::setSenderboxAlias()
     * @uses SystemUser::setTitle()
     * @uses SystemUser::setType()
     * @uses SystemUser::setSystemCreateDate()
     * @uses SystemUser::setFirstCreateDate()
     * @param bool $enabled
     * @param string $identifier
     * @param string $postboxAlias
     * @param string $senderboxAlias
     * @param string $title
     * @param string $type
     * @param string $systemCreateDate
     * @param string $firstCreateDate
     */
    public function __construct($enabled = null, $identifier = null, $postboxAlias = null, $senderboxAlias = null, $title = null, $type = null, $systemCreateDate = null, $firstCreateDate = null)
    {
        $this
            ->setEnabled($enabled)
            ->setIdentifier($identifier)
            ->setPostboxAlias($postboxAlias)
            ->setSenderboxAlias($senderboxAlias)
            ->setTitle($title)
            ->setType($type)
            ->setSystemCreateDate($systemCreateDate)
            ->setFirstCreateDate($firstCreateDate);
    }
    /**
     * Get Enabled value
     * @return bool
     */
    public function getEnabled()
    {
        return $this->Enabled;
    }
    /**
     * Set Enabled value
     * @param bool $enabled
     * @return \Mnm\StructType\SystemUser
     */
    public function setEnabled($enabled = null)
    {
        $this->Enabled = $enabled;
        return $this;
    }
    /**
     * Get Identifier value
     * @return string|null
     */
    public function getIdentifier()
    {
        return $this->Identifier;
    }
    /**
     * Set Identifier value
     * @param string $identifier
     * @return \Mnm\StructType\SystemUser
     */
    public function setIdentifier($identifier = null)
    {
        $this->Identifier = $identifier;
        return $this;
    }
    /**
     * Get PostboxAlias value
     * @return string|null
     */
    public function getPostboxAlias()
    {
        return $this->PostboxAlias;
    }
    /**
     * Set PostboxAlias value
     * @param string $postboxAlias
     * @return \Mnm\StructType\SystemUser
     */
    public function setPostboxAlias($postboxAlias = null)
    {
        $this->PostboxAlias = $postboxAlias;
        return $this;
    }
    /**
     * Get SenderboxAlias value
     * @return string|null
     */
    public function getSenderboxAlias()
    {
        return $this->SenderboxAlias;
    }
    /**
     * Set SenderboxAlias value
     * @param string $senderboxAlias
     * @return \Mnm\StructType\SystemUser
     */
    public function setSenderboxAlias($senderboxAlias = null)
    {
        $this->SenderboxAlias = $senderboxAlias;
        return $this;
    }
    /**
     * Get Title value
     * @return string|null
     */
    public function getTitle()
    {
        return $this->Title;
    }
    /**
     * Set Title value
     * @param string $title
     * @return \Mnm\StructType\SystemUser
     */
    public function setTitle($title = null)
    {
        $this->Title = $title;
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param string $type
     * @return \Mnm\StructType\SystemUser
     */
    public function setType($type = null)
    {
        $this->Type = $type;
        return $this;
    }
    /**
     * Get SystemCreateDate value
     * @return string|null
     */
    public function getSystemCreateDate()
    {
        return $this->SystemCreateDate;
    }
    /**
     * Set SystemCreateDate value
     * @param string $systemCreateDate
     * @return \Mnm\StructType\SystemUser
     */
    public function setSystemCreateDate($systemCreateDate = null)
    {
        $this->SystemCreateDate = $systemCreateDate;
        return $this;
    }
    /**
     * Get FirstCreateDate value
     * @return string|null
     */
    public function getFirstCreateDate()
    {
        return $this->FirstCreateDate;
    }
    /**
     * Set FirstCreateDate value
     * @param string $firstCreateDate
     * @return \Mnm\StructType\SystemUser
     */
    public function setFirstCreateDate($firstCreateDate = null)
    {
        $this->FirstCreateDate = $firstCreateDate;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Mnm\StructType\SystemUser
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
